--- res/res_musiconhold.c	2007-11-06 15:18:49.000000000 -0500
+++ /usr/src/asterisk-1.4.15/res/res_musiconhold.c	2007-12-16 23:24:53.000000000 -0500
@@ -863,15 +863,13 @@
 
 	AST_LIST_LOCK(&mohclasses);
 	if ((mohclass = get_mohbyname(moh->name, 0))) {
-		mohclass->delete = 0;
-		if (reload) {
-			ast_log(LOG_DEBUG, "Music on Hold class '%s' left alone from initial load.\n", moh->name);
-		} else {
+		if ( !mohclass->delete ) {
+			mohclass->delete = 0;
 			ast_log(LOG_WARNING, "Music on Hold class '%s' already exists\n", moh->name);
+			free(moh);	
+			AST_LIST_UNLOCK(&mohclasses);
+			return -1;
 		}
-		free(moh);	
-		AST_LIST_UNLOCK(&mohclasses);
-		return -1;
 	}
 	AST_LIST_UNLOCK(&mohclasses);
 
